#include <stdio.h>
#include <stdlib.h>

long long N,Q,d[300010],p[300010],k[300010],i,j,l,br,z;

long long plazma(long long d[], long long p[], long long k[], long long j)
{
    z=0;
    br=0;

    i=0;
    l=0;
    while(l!=k[j])
    {

      if(l==d[i]-1)
      {
        z+=p[i];
        i++;
      }

      if(z>0)
      {
          z--;
          br++;
      }

        l++;
    }
    return br;
}

int main()
{
    scanf("%lld%lld",&N,&Q);

    for(i=0;i<N;i++)
        scanf("%lld%lld",&d[i],&p[i]);

    for(i=0;i<Q;i++)
        scanf("%lld",&k[i]);

    j=0;
    while(j!=Q)
    {
        printf("%lld\n",plazma(d,p,k,j));
        j++;
    }

    return 0;
}